# IRremoteESP8266: IRTranscoldAc Class Reference

IRTranscoldAc Class Reference

Class for handling detailed Transcold A/C messages. More...

`#include <ir_Transcold.h>`

Collaboration diagram for IRTranscoldAc:
[legend]

## Public Member Functions

| IRTranscoldAc (const uint16_t pin, const bool inverted=false, const bool use_modulation=true)
| Class constructor. More...
void | stateReset ()
| Reset the internal state to a fixed known good state. More...
void | send (const uint16_t repeat=kTranscoldDefaultRepeat)
| Send the current internal state as an IR message. More...
int8_t | calibrate (void)
| Run the calibration to calculate uSec timing offsets for this platform. More...
void | begin ()
| Set up hardware to be able to send a message. More...
void | on ()
| Change the power setting to On. More...
void | off ()
| Change the power setting to Off. More...
void | setPower (const bool state)
| Change the power setting. More...
bool | getPower ()
| Get the value of the current power setting. More...
void | setTemp (const uint8_t temp)
| Set the temperature. More...
uint8_t | getTemp ()
| Get the current temperature setting. More...
void | setFan (const uint8_t speed, const bool modecheck=true)
| Set the speed of the fan. More...
uint8_t | getFan ()
| Get the current fan speed setting. More...
void | setMode (const uint8_t mode)
| Set the operating mode of the A/C. More...
uint8_t | getMode ()
| Get the operating mode setting of the A/C. More...
void | setSwing ()
| Toggle the Swing mode of the A/C. More...
bool | getSwing ()
| Get the Swing setting of the A/C. More...
uint32_t | getRaw ()
| Get a copy of the internal state as a valid code for this protocol. More...
void | setRaw (const uint32_t new_code)
| Set the internal state from a valid code for this protocol. More...
uint8_t | convertMode (const stdAc::opmode_t mode)
| Convert a standard A/C mode into its native mode. More...
uint8_t | convertFan (const stdAc::fanspeed_t speed)
| Convert a stdAc::fanspeed_t enum into it's native speed. More...
stdAc::state_t | toCommon (const stdAc::state_t *prev=NULL)
| Convert the A/C state to it's common stdAc::state_t equivalent. More...
String | toString ()
| Convert the internal state into a human readable string. More...

## Static Public Member Functions

static stdAc::opmode_t | toCommonMode (const uint8_t mode)
| Convert a native mode to it's common stdAc::opmode_t equivalent. More...
static stdAc::fanspeed_t | toCommonFanSpeed (const uint8_t speed)
| Convert a native fan speed into its stdAc equivalent. More...

## Private Member Functions

void | setTempRaw (const uint8_t code)
| Set the raw (native) temperature value. More...
uint8_t | getTempRaw ()
| Get the raw (native) temperature value. More...
bool | isSpecialState (void)
| Is the current state is a special state? More...
bool | handleSpecialState (const uint32_t data)
| Adjust any internal settings based on the type of special state we are supplied. Does nothing if it isn't a special state. More...
void | updateSavedState (void)
| Backup the current internal state as long as it isn't a special state. More...
void | recoverSavedState (void)
| Restore the current internal state from backup as long as it isn't a special state. More...
uint32_t | getNormalState (void)

## Private Attributes

IRsend | _irsend
| Instance of the IR send class. More...
bool | powerFlag
bool | swingFlag
bool | swingHFlag
bool | swingVFlag
uint32_t | remote_state
| The state of the IR remote in IR code form. More...
uint32_t | saved_state
| Copy of the state if we required a special mode. More...

## Detailed Description

Class for handling detailed Transcold A/C messages.

## Constructor & Destructor Documentation

## IRTranscoldAc()

IRTranscoldAc::IRTranscoldAc | ( | const uint16_t | pin,
|  | const bool | inverted = `false`,
|  | const bool | use_modulation = `true`
| ) |  |

explicit

Class constructor.

Parameters

  [in] | pin | GPIO to be used when sending.
  [in] | inverted | Is the output signal to be inverted?
  [in] | use_modulation | Is frequency modulation to be used?

## Member Function Documentation

## begin()

void IRTranscoldAc::begin | ( |  | ) |

Set up hardware to be able to send a message.

## calibrate()

int8_t IRTranscoldAc::calibrate | ( | void |  | ) |

inline

Run the calibration to calculate uSec timing offsets for this platform.

Returns
  The uSec timing offset needed per modulation of the IR Led.

Note
  This will produce a 65ms IR signal pulse at 38kHz. Only ever needs to be run once per object instantiation, if at all.

## convertFan()

uint8_t IRTranscoldAc::convertFan | ( | const stdAc::fanspeed_t | speed | ) |

Convert a stdAc::fanspeed_t enum into it's native speed.

Parameters

  [in] | speed | The enum to be converted.

Returns
  The native equivalent of the enum.

## convertMode()

uint8_t IRTranscoldAc::convertMode | ( | const stdAc::opmode_t | mode | ) |

Convert a standard A/C mode into its native mode.

Parameters

  [in] | mode | A stdAc::opmode_t to be converted to it's native equivalent.

Returns
  The corresponding native mode.

## getFan()

uint8_t IRTranscoldAc::getFan | ( |  | ) |

Get the current fan speed setting.

Returns
  The current fan speed.

## getMode()

uint8_t IRTranscoldAc::getMode | ( |  | ) |

Get the operating mode setting of the A/C.

Returns
  The current operating mode setting.

## getNormalState()

uint32_t IRTranscoldAc::getNormalState | ( | void |  | ) |

private

## getPower()

bool IRTranscoldAc::getPower | ( |  | ) |

Get the value of the current power setting.

Returns
  true, the setting is on. false, the setting is off.

## getRaw()

uint32_t IRTranscoldAc::getRaw | ( |  | ) |

Get a copy of the internal state as a valid code for this protocol.

Returns
  A valid code for this protocol based on the current internal state.

## getSwing()

bool IRTranscoldAc::getSwing | ( |  | ) |

Get the Swing setting of the A/C.

Returns
  true, the setting is on. false, the setting is off.

## getTemp()

uint8_t IRTranscoldAc::getTemp | ( |  | ) |

Get the current temperature setting.

Returns
  The current setting for temp. in degrees celsius.

## getTempRaw()

uint8_t IRTranscoldAc::getTempRaw | ( |  | ) |

private

Get the raw (native) temperature value.

Returns
  The native temperature value.

## handleSpecialState()

bool IRTranscoldAc::handleSpecialState | ( | const uint32_t | data | ) |

private

Adjust any internal settings based on the type of special state we are supplied. Does nothing if it isn't a special state.

Parameters

  [in] | data | The state we need to act upon.

Note
  Special state means commands that are not affecting Temperature/Mode/Fan

Returns
  true, if it is a special state. false if it isn't.

## isSpecialState()

bool IRTranscoldAc::isSpecialState | ( | void |  | ) |

private

Is the current state is a special state?

Returns
  true, if it is. false if it isn't.

## off()

void IRTranscoldAc::off | ( |  | ) |

Change the power setting to Off.

## on()

void IRTranscoldAc::on | ( |  | ) |

Change the power setting to On.

## recoverSavedState()

void IRTranscoldAc::recoverSavedState | ( | void |  | ) |

private

Restore the current internal state from backup as long as it isn't a special state.

## send()

void IRTranscoldAc::send | ( | const uint16_t | repeat = `kTranscoldDefaultRepeat` | ) |

Send the current internal state as an IR message.

Parameters

  [in] | repeat | Nr. of times the message will be repeated.

## setFan()

void IRTranscoldAc::setFan | ( | const uint8_t | speed,
|  | const bool | modecheck = `true`
| ) |  |

Set the speed of the fan.

Parameters

  [in] | speed | The desired setting.
  [in] | modecheck | Do we enforce any mode limitations before setting?

## setMode()

void IRTranscoldAc::setMode | ( | const uint8_t | mode | ) |

Set the operating mode of the A/C.

Parameters

  [in] | mode | The desired operating mode.

## setPower()

void IRTranscoldAc::setPower | ( | const bool | on | ) |

Change the power setting.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## setRaw()

void IRTranscoldAc::setRaw | ( | const uint32_t | new_code | ) |

Set the internal state from a valid code for this protocol.

Parameters

  [in] | new_code | A valid code for this protocol.

## setSwing()

void IRTranscoldAc::setSwing | ( |  | ) |

Toggle the Swing mode of the A/C.

## setTemp()

void IRTranscoldAc::setTemp | ( | const uint8_t | desired | ) |

Set the temperature.

Parameters

  [in] | desired | The temperature in degrees celsius.

## setTempRaw()

void IRTranscoldAc::setTempRaw | ( | const uint8_t | code | ) |

private

Set the raw (native) temperature value.

Note
  Bypasses any checks.

Parameters

  [in] | code | The desired native temperature.

## stateReset()

void IRTranscoldAc::stateReset | ( |  | ) |

Reset the internal state to a fixed known good state.

## toCommon()

stdAc::state_t IRTranscoldAc::toCommon | ( | const stdAc::state_t * | prev = `NULL` | ) |

Convert the A/C state to it's common stdAc::state_t equivalent.

Parameters

  [in] | prev | Ptr to the previous state if required.

Returns
  A stdAc::state_t state.

## toCommonFanSpeed()

stdAc::fanspeed_t IRTranscoldAc::toCommonFanSpeed | ( | const uint8_t | speed | ) |

static

Convert a native fan speed into its stdAc equivalent.

Parameters

  [in] | speed | The native setting to be converted.

Returns
  The stdAc equivalent of the native setting.

## toCommonMode()

stdAc::opmode_t IRTranscoldAc::toCommonMode | ( | const uint8_t | mode | ) |

static

Convert a native mode to it's common stdAc::opmode_t equivalent.

Parameters

  [in] | mode | A native operation mode to be converted.

Returns
  The corresponding common stdAc::opmode_t mode.

## toString()

String IRTranscoldAc::toString | ( |  | ) |

Convert the internal state into a human readable string.

Returns
  The current internal state expressed as a human readable String.

## updateSavedState()

void IRTranscoldAc::updateSavedState | ( | void |  | ) |

private

Backup the current internal state as long as it isn't a special state.

Note
  : Must be called before every special state to make sure the remote_state is safe

## Member Data Documentation

## _irsend

IRsend IRTranscoldAc::_irsend

private

Instance of the IR send class.

## powerFlag

bool IRTranscoldAc::powerFlag

private

## remote_state

uint32_t IRTranscoldAc::remote_state

private

The state of the IR remote in IR code form.

## saved_state

uint32_t IRTranscoldAc::saved_state

private

Copy of the state if we required a special mode.

## swingFlag

bool IRTranscoldAc::swingFlag

private

## swingHFlag

bool IRTranscoldAc::swingHFlag

private

## swingVFlag

bool IRTranscoldAc::swingVFlag

private

The documentation for this class was generated from the following files:

- src/ir_Transcold.h
- src/ir_Transcold.cpp